summaryrefslogtreecommitdiffstats
path: root/source.local/l/boost
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2013-03-22 16:47:17 -0700
committer Eric Hameleers <alien@slackware.com>2013-03-22 16:47:17 -0700
commit69dd99f961988fa15da8d7f0d63b62f3385419c3 (patch)
treed57eb3e85e1d08e7815787de26946ee42c398b66 /source.local/l/boost
downloadalienarm-69dd99f961988fa15da8d7f0d63b62f3385419c3.tar.gz
alienarm-69dd99f961988fa15da8d7f0d63b62f3385419c3.tar.xz
Initial commit of a Slackware cross-arch bootstrap framework.
Diffstat (limited to 'source.local/l/boost')
-rwxr-xr-xsource.local/l/boost/boost.SlackBuild161
-rw-r--r--source.local/l/boost/slack-desc19
2 files changed, 180 insertions, 0 deletions
diff --git a/source.local/l/boost/boost.SlackBuild b/source.local/l/boost/boost.SlackBuild
new file mode 100755
index 0000000..e15fe9b
--- /dev/null
+++ b/source.local/l/boost/boost.SlackBuild
@@ -0,0 +1,161 @@
+#!/bin/sh
+
+# Copyright 2007, 2008 Eric Hameleers, Eindhoven, NL
+# Copyright 2007-2008 Heinz Wiesinger
+# Copyright 2008, 2009, 2010 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# bjam-build system mostly taken from SlackBuild by Eric Hameleers
+# Script modified by Robby Workman - no copyright claims or added terms
+# Modified 2012 by Eric Hameleers <alien at slackware.com> for ARM port.
+
+
+PKGNAM=boost
+VERSION=${VERSION:-$(echo $PKGNAM_*.tar.?z* | rev | cut -f 3- -d . | rev | cut -f 2- -d _)}
+BUILD=${BUILD:-1}
+
+ICU=${ICU:-no}
+PKG_VERSION=$(echo $VERSION | tr _ .) # Leave this alone
+
+# Automatically determine the architecture we're building on:
+MARCH=$( uname -m )
+if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i486 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+fi
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-boost
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf boost_$VERSION
+tar xvf $CWD/boost_$VERSION.tar.?z* || exit 1
+cd boost_$VERSION || exit 1
+
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# Apply Hotfixes from:
+# http://svn.boost.org/trac/boost/wiki/ReleasePractices/HotFixes
+#
+# (none currently for this $VERSION)
+
+# This is the python we build against:
+PYTHON_VERSION=$(python -c 'import sys; print sys.version[:3]')
+PYTHON_FLAGS="-sPYTHON_ROOT=/usr -sPYTHON_VERSION=$PYTHON_VERSION"
+
+# First build bjam, the boost build system:
+cd tools/build/v2/engine/src
+ CFLAGS="$SLKCFLAGS -fno-strict-aliasing" CC=gcc ./build.sh cc
+cd -
+
+BJAM=$(find tools/build/v2/engine/src/ -name bjam -a -type f)
+
+# Create build subdirectory
+mkdir obj
+
+# Change the build options from 'minimal' to what we want, since adding
+# "-sBUILD=<optimization>speed <inlining>full <threading>single/multi
+# <link>shared <runtime-link>shared" to $BJAM command no longer seems to work.
+FLAGS="<threading>multi <threading>single <optimization>speed <inlining>full"
+sed -i "s/ <threading>multi/ $FLAGS/" Jamroot
+# Disable static libraries ( the only software that *requires* the static libs,
+# is Microsoft's CW compiler (CW or Comega is an experimental language which
+# extends C# )
+sed -i "s/<link>shared <link>static/<link>shared/" Jamroot
+
+# Next, we build boost using bjam
+$BJAM \
+ release \
+ "-sNO_COMPRESSION=0" \
+ "-sZLIB_INCLUDE=/usr/include" \
+ "-sZLIB_LIBPATH=/usr/lib${LIBDIRSUFFIX}" \
+ "-sBZIP2_INCLUDE=/usr/include" \
+ "-sBZIP2_LIBPATH=/usr/lib${LIBDIRSUFFIX}" \
+ "-sEXPAT_INCLUDE=/usr/include" \
+ "-sEXPAT_LIBPATH=/usr/lib${LIBDIRSUFFIX}" \
+ --toolset=gcc \
+ --layout=system \
+ --builddir=obj \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --build-type=minimal \
+ $PYTHON_FLAGS \
+ stage
+
+# And then install boost..
+mkdir -p $PKG/usr/{lib$LIBDIRSUFFIX,include}
+
+$BJAM \
+ release \
+ "-sEXPAT_INCLUDE=/usr/include" \
+ "-sEXPAT_LIBPATH=/usr/lib${LIBDIRSUFFIX}" \
+ --toolset=gcc \
+ --layout=system \
+ --builddir=obj \
+ --prefix=$PKG/usr \
+ --libdir=$PKG/usr/lib${LIBDIRSUFFIX} \
+ --build-type=minimal \
+ $PYTHON_FLAGS \
+ install
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" \
+ | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+mkdir -p $PKG/usr/doc/boost-$PKG_VERSION
+# Do not copy 44MB of developer 'doc/html' into our package...
+cp -a LICENSE* index.html $PKG/usr/doc/boost-$PKG_VERSION
+find $PKG/usr/doc -type f -exec chmod 0644 {} \;
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n /tmp/boost-$PKG_VERSION-$ARCH-$BUILD.txz
+
diff --git a/source.local/l/boost/slack-desc b/source.local/l/boost/slack-desc
new file mode 100644
index 0000000..1b3142a
--- /dev/null
+++ b/source.local/l/boost/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+boost: boost (Boost C++ Libraries)
+boost:
+boost: Boost provides free peer-reviewed portable C++ source libraries.
+boost: The emphasis is on libraries that work well with the C++ Standard
+boost: Library. One goal is to establish "existing practice" and provide
+boost: reference implementations so that the Boost libraries are suitable
+boost: for eventual standardization.
+boost:
+boost: Homepage: http://www.boost.org/
+boost:
+boost: